<!DOCTYPE html>

<!--
    enviar.php

    Envío de información entre 2 páginas en PHP en formato JSON con generacion de certificado

    Rogelio Ferreira Escutia - diciembre 2020
-->

<?php
    echo "<h3>Servidor 1</h3>";
    
    # Datos a enviar
    echo "<h4>Datos a enviar:</h4>";
    $login = "rogelio";
    $descripcion = "cliente";
    echo "Login: " . $login;
    echo "<br />Descripcion: " . $descripcion;
    $persona = [
        "login" => $login,
        "descripcion" => $descripcion,
    ];
    
    # Codificación de los datos en JSON
    $datosCodificados = json_encode($persona);	

    # Direccion a donde se van a enviar los datos (Servidor 2)
    $url = "http://localhost/php_transferencia_json/api.php";
    $ch = curl_init($url);

    curl_setopt_array($ch, array(
        CURLOPT_CUSTOMREQUEST => "POST",                    // Indicar que vamos a hacer una petición POST
        CURLOPT_POSTFIELDS => $datosCodificados,            // Aquí se colocan los datos dentro del cuerpo
        CURLOPT_HTTPHEADER => array(                        // Encabezados
            'Content-Type: application/json',               //CURLOPT_HEADER => true,
            'Content-Length: ' . strlen($datosCodificados), // Abajo podríamos agregar más encabezados
            'Personalizado: ¡Hola mundo!',                  // Un encabezado personalizado
        ),
    # indicar que regrese los datos, no que los imprima directamente
    CURLOPT_RETURNTRANSFER => true,
    ));

    # Enviar los datos
    echo "<h3>Enviado datos al Servidor 2</h3>";
    $resultado = curl_exec($ch);
    
    # Verificar si el código es 200, es decir, HTTP_OK
    $codigoRespuesta = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    if($codigoRespuesta === 200){
        # Decodificar la respuesta que viene en JSON
        $respuestaDecodificada = json_decode($resultado);
        # Impresion de los datos que regresa el servidor
        echo "<h3>Datos que vienen del Servidor 2</h3>";
        echo "<strong>Nombre: </strong>" . $respuestaDecodificada->nombre;
        echo "<br><strong>Certificado: </strong>" . $respuestaDecodificada->certificado;
    } else {
        # Error
        echo "Error consultando. Código de respuesta: $codigoRespuesta";
    }
    curl_close($ch);
?>